#include <iostream>
#include <vector>
using namespace std;
const int NMAX = 10000+10;
const int MMAX = 20000+10;
struct edge
{ int u,v; };
edge e[MMAX];
vector<int> a[NMAX];
int visited[NMAX];
int n, m, cnt;
void dfs(int u)
{  visited[u] = 1;
for(int i=0; i<a[u].size(); i++)
if(visited[a[u][i]] == 0)
dfs(a[u][i]);
}
void remove(int u, int v)
{  int i=0;
while(a[u][i] != v) i++;
a[u][i] = a[u][a[u].size()-1];
a[u].pop_back();
i=0;
while(a[v][i] != u) i++;
a[v][i] = a[v][a[v].size()-1];
a[v].pop_back();
}
void restore(int u, int v)
{ a[u].push_back(v);
a[v].push_back(u);
}
int main()
{
cin >> n >> m;
for(int i=0; i<m; i++)
{ int u,v;
cin >> u >> v;
e[i].u = u; e[i].v = v;
a[u].push_back(v);
a[v].push_back(u);
}
cnt = 0;
for(int i=0; i<m; i++)
{ int u = e[i].u, v = e[i].v;
remove(u,v);
for(int i=1; i<=n; i++) visited[i] = 0;
dfs(u);
if(visited[v] == 0) cnt++;
restore(u,v);
}
cout << cnt << endl;
return 0;
}
